var gulp = require('gulp');
var $ = require('gulp-load-plugins')();
var browserSync = require('browser-sync').create();

var sassPaths = [
    '../dss-addon-framework/responsive-ui/resources/scss',
    '../dss-addon-framework/responsive-ui/bower-components/foundation-sites/scss'   // @TODO: make it work with util/util import in framework's _settings.scss
];

const includepartials = gulp.task('includepartials', function () {
  return gulp.src('ui/resources/*.html')
    .pipe($.fileInclude({
      prefix: '@@',
      basepath: 'ui/resources/partials'
    }))
    /* .pipe($.rename({
        prefix: 'dev-'
    })) */
    .pipe(gulp.dest('ui/'));
});

const sass = gulp.task('sass', function () {
    return gulp.src('ui/resources/scss/app.scss')
		.pipe($.sass({
			includePaths: sassPaths,
			outputStyle: 'compressed' // if css compressed **file size**
		})
		.on('error', $.sass.logError))
		.pipe($.autoprefixer({
			browsers: ['last 2 versions', 'ie >= 9']
		}))
		.pipe(gulp.dest('ui/resources/css'));
});

gulp.task('build', gulp.parallel('includepartials', 'sass'));

gulp.task('default', gulp.series(gulp.parallel('includepartials', 'sass'), function () {
    gulp.watch([ 'ui/resources/*.html', 'ui/resources/partials/**/*.html' ], includepartials);
    gulp.watch('ui/*.html', browserSync.reload);
    gulp.watch('ui/resources/scss/**/*.scss', sass);
    gulp.watch('ui/resources/css/**/*.css', browserSync.reload);
    gulp.watch('ui/js/**/*.js', browserSync.reload);
    browserSync.init({
        server: {
            baseDir: 'ui/',
            index: 'index.html'
        }
    });
}));
